# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section   devel
%define base_name commons-messenger
%define jakarta_version 1.0

Name:           jakarta-%{base_name}
Version:        1.0.d10
Release:        5jpp
Epoch:          0
Summary:        Commons Messenger JMS framework 

Group:          Development/Libraries/Java
License:        Apache Software License
URL:            http://jakarta.apache.org/commons/sandbox/messenger/
Source0:        http://cvs.apache.org/builds/jakarta-commons/nightly/commons-messenger/commons-messenger-src-20040113.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Distribution:   JPackage
Vendor:         JPackage Project

%if ! %{gcj_support}
BuildArch:      noarch
%endif

BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit >= 0:1.6
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  jakarta-commons-logging >= 0:1.0.3
BuildRequires:  jakarta-commons-beanutils >= 0:1.6.1
BuildRequires:  jakarta-commons-collections >= 0:2.1
BuildRequires:  jakarta-commons-digester >= 0:1.5
BuildRequires:  servletapi4 >= 0:4.0.4
BuildRequires:  jms >= 0:1.1
BuildRequires:  jta >= 0:1.0.1
BuildRequires:  xml-commons-apis >= 0:1.0
Requires:       jakarta-commons-logging >= 0:1.0.3
Requires:       jakarta-commons-beanutils >= 0:1.6.1
Requires:       jakarta-commons-collections >= 0:2.1
Requires:       jakarta-commons-digester >= 0:1.5
Requires:       servletapi4 >= 0:4.0.4
Requires:       jms >= 0:1.1
Requires:       jta >= 0:1.0.1
Requires:       xml-commons-apis >= 0:1.0
Requires:       jaxp_parser_impl
%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif


%description
Messenger is a JMS (Java Message Service) framework which makes it 
very easy to use JMS in Web Service and Web Application environments. 
Messenger implements session pooling (which can be quite hard to do 
with JMS) which makes JMS very easy to work with. Also Messenger hides 
much of the complexity of JMS behind a simple facade API, the Messenger 
interface. 
In addition Messenger provides an XML deployment configuration file to 
avoid having to litter your code with complex deployment configuration 
details in your application code. 
Messenger also provides a Messagelet Engine which is a JMS based 
container that can be deployed in any Servlet Engine to process JMS 
messages via MessageListeners, Message Driven Objects, Servlets or JSP. 

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description    javadoc
%{summary}.

%prep
%setup -q -n %{base_name}

%build
export OPT_JAR_LIST="ant/ant-junit junit"
export CLASSPATH=$(build-classpath \
jakarta-commons-logging-api \
jakarta-commons-logging jakarta-commons-beanutils jakarta-commons-collections \
jakarta-commons-digester servletapi4 jms jta xml-commons-apis)
CLASSPATH=target/classes:target/test-classes:$CLASSPATH
ant -Dbuild.sysclasspath=only test dist

%install
rm -rf $RPM_BUILD_ROOT
install -Dpm 644 dist/%{base_name}-%{jakarta_version}-dev-10.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
ln -s %{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}-%{version}.jar
ln -s %{base_name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}.jar
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%doc LICENSE.txt README.txt RELEASE-NOTES.txt
%{_javadir}/*.jar
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Thu Mar 01 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0.d10-5jpp
- First JPP-1.7 release
- Add gcj_support option

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0.d10-4jpp
- Rebuild with ant-1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0.d10-3jpp
- Void change

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:1.0.d10-2jpp
- Upgrade to Ant 1.6.X

* Mon Jan 19 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0.d10-1jpp
- First JPackage release
